"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;
var _reactNative = require("react-native");
var _react = _interopRequireWildcard(require("react"));
var _reactNativeGestureHandler = require("react-native-gesture-handler");
var _reactNativeReanimated = _interopRequireWildcard(require("react-native-reanimated"));
var _helper_functions = require("./utilis/helper_functions");
function _getRequireWildcardCache(e) { if ("function" != typeof WeakMap) return null; var r = new WeakMap(), t = new WeakMap(); return (_getRequireWildcardCache = function (e) { return e ? t : r; })(e); }
function _interopRequireWildcard(e, r) { if (!r && e && e.__esModule) return e; if (null === e || "object" != typeof e && "function" != typeof e) return { default: e }; var t = _getRequireWildcardCache(r); if (t && t.has(e)) return t.get(e); var n = { __proto__: null }, a = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var u in e) if ("default" !== u && Object.prototype.hasOwnProperty.call(e, u)) { var i = a ? Object.getOwnPropertyDescriptor(e, u) : null; i && (i.get || i.set) ? Object.defineProperty(n, u, i) : n[u] = e[u]; } return n.default = e, t && t.set(e, n), n; }
//@ts-ignore

const SCREEN_WIDTH = _reactNative.Dimensions.get('window').width;
const NO_WIDTH_SPACE = '​';
const TextComp = /*#__PURE__*/(0, _react.memo)(({
  word,
  i,
  addRange,
  values,
  textColor,
  highlightedTextColor,
  highlightColor,
  lineBreakHeight = 5,
  lineSpace = 2,
  textStyle,
  textBackgroundColor = 'transparent'
}) => {
  const derivedValue = (0, _reactNativeReanimated.useDerivedValue)(() => {
    const map = values.value;
    let bgColor = textBackgroundColor;
    let color = textColor;
    for (let a = 0; a < map.length; a++) {
      const data = values.value[a];
      if (data.start === i) {
        bgColor = highlightColor;
        color = highlightedTextColor;
      }
      if (data.end >= i && data.start <= i) {
        bgColor = highlightColor;
        color = highlightedTextColor;
      }
    }
    return {
      ...textStyle,
      backgroundColor: bgColor,
      color,
      marginBottom: lineSpace
    };
  });
  const animatedStyles = (0, _reactNativeReanimated.useAnimatedStyle)(() => {
    return derivedValue.value;
  });
  const onLayout = (0, _react.useCallback)(e => {
    const {
      y
    } = e.nativeEvent.layout;
    addRange(y, e.nativeEvent.layout, word);
  }, []);
  const styles = _reactNative.StyleSheet.create({
    view: {
      width: SCREEN_WIDTH,
      height: lineBreakHeight
    }
  });
  return word === '<br/>' ? /*#__PURE__*/_react.default.createElement(_reactNative.View, {
    onLayout: onLayout,
    style: styles.view
  }) : /*#__PURE__*/_react.default.createElement(_reactNativeReanimated.default.Text, {
    onLayout: onLayout,
    style: [animatedStyles]
  }, /*#__PURE__*/_react.default.createElement(_reactNative.Text, null, word, " "), NO_WIDTH_SPACE);
});
const BreakText = ({
  words,
  addRange,
  values,
  textColor,
  highlightedTextColor,
  highlightColor,
  lineBreakHeight,
  lineSpace,
  textStyle,
  textBackgroundColor
}) => {
  return /*#__PURE__*/_react.default.createElement(_react.default.Fragment, null, words.map((word, i) => {
    return /*#__PURE__*/_react.default.createElement(TextComp, {
      key: i,
      word,
      i,
      addRange,
      values,
      textColor,
      highlightedTextColor,
      highlightColor,
      lineBreakHeight,
      lineSpace,
      textStyle,
      textBackgroundColor
    });
  }));
};
const HighlightText = /*#__PURE__*/_react.default.forwardRef(({
  text,
  textColor,
  highlightedTextColor,
  highlightColor,
  lineBreakHeight,
  lineSpace,
  highlightInitialDelay = 150,
  onHighlightStart,
  onHighlightEnd,
  initialHighlightData = [],
  textStyle,
  marginBottom,
  marginTop,
  marginLeft,
  marginRight,
  onHighlightTapped,
  clearHighlightOnTap,
  margin,
  backgroundColor,
  textBackgroundColor
}, ref) => {
  const words = (0, _react.useMemo)(() => text.split(' '), [text]);
  const layout = (0, _reactNativeReanimated.useSharedValue)();
  const rangeMap = (0, _reactNativeReanimated.useSharedValue)({});
  const start = (0, _reactNativeReanimated.useSharedValue)();
  const values = (0, _reactNativeReanimated.useSharedValue)(initialHighlightData);
  const prev = (0, _reactNativeReanimated.useSharedValue)();
  const layoutDone = (0, _react.useRef)(false);
  let map = {};
  let count = 0;
  function addRange(lowerBound, value) {
    'worklet';

    if (layoutDone.current) {
      map = {};
      count = 0;
      layoutDone.current = false;
    }
    const arr = map[lowerBound] ?? [];
    arr.push(value.x + value.width);
    map[lowerBound] = arr.sort((a, b) => a - b);
    count++;
    if (count >= words.length) {
      rangeMap.value = map;
      layoutDone.current = true;
    }
  }
  const calTap = e => {
    'worklet';

    const keys = Object.keys(rangeMap.value);
    const {
      result,
      words
    } = (0, _helper_functions.findValueLessThanOrEqualToNumber)(keys, e.absoluteY - layout.value.y, rangeMap.value);
    const i = (0, _helper_functions.findIndexLessThanOrEqual)(rangeMap.value[result], e.absoluteX - layout.value.x);
    return {
      i,
      words
    };
  };
  const getHighlightedData = () => {
    return values.value;
  };
  const deleteHighlight = id => {
    values.value.splice(id, 1, {
      start: -1,
      end: -1
    });
    values.value = [...values.value];
  };
  _react.default.useImperativeHandle(ref, () => ({
    getHighlightedData,
    deleteHighlight
  }));
  const tap = _reactNativeGestureHandler.Gesture.Tap().onStart(e => {
    const {
      i,
      words
    } = calTap(e);
    for (let a = values.value.length - 1; a >= 0; a--) {
      const item = values.value[a];
      if (i + words >= item.start && i + words <= item.end) {
        if (clearHighlightOnTap) {
          (0, _reactNativeReanimated.runOnJS)(deleteHighlight)(a);
        }
        (0, _reactNativeReanimated.runOnJS)(onHighlightTapped)(a, e);
        break;
      }
    }
  });
  const pan = _reactNativeGestureHandler.Gesture.Pan().activateAfterLongPress(highlightInitialDelay).onStart(e => {
    (0, _reactNativeReanimated.runOnJS)(onHighlightStart)();
    const {
      i,
      words
    } = calTap(e);
    start.value = i + words;
    prev.value = values.value;
    values.value = [...prev.value, {
      start: i + words,
      end: i + words
    }];
  }).onUpdate(e => {
    if (e.absoluteY >= layout.value.y && e.absoluteX < layout.value.x + layout.value.width) {
      const {
        i,
        words
      } = calTap(e);
      if (i + words < start.value) {
        values.value = [...values.value.slice(0, values.value.length - 1), {
          start: i + words,
          end: start.value
        }];
      } else {
        values.value = [...values.value.slice(0, values.value.length - 1), {
          start: start.value,
          end: i + words
        }];
      }
    }
  }).onEnd(() => {
    (0, _reactNativeReanimated.runOnJS)(onHighlightEnd)(values.value.length - 1);
  });
  const composed = _reactNativeGestureHandler.Gesture.Race(tap, pan);
  const styles = _reactNative.StyleSheet.create({
    mainViewStyle: {
      flexDirection: 'row',
      flexWrap: 'wrap',
      margin,
      marginBottom,
      marginTop,
      marginLeft,
      marginRight,
      backgroundColor
    }
  });
  const onLayout = (0, _react.useCallback)(e => {
    layout.value = e.nativeEvent.layout;
  }, [layout]);
  return /*#__PURE__*/_react.default.createElement(_reactNativeGestureHandler.GestureDetector, {
    gesture: composed
  }, /*#__PURE__*/_react.default.createElement(_reactNative.View, {
    style: styles.mainViewStyle,
    onLayout: onLayout
  }, /*#__PURE__*/_react.default.createElement(BreakText, {
    words,
    addRange,
    values,
    textColor,
    highlightedTextColor,
    highlightColor,
    lineBreakHeight,
    lineSpace,
    textStyle,
    textBackgroundColor
  })));
});
var _default = exports.default = HighlightText;
//# sourceMappingURL=HighlightText.js.map